// -*- MaTX -*-

// sim00006.mm: tmd00006.{h,mm} ΥƥȤΤΥߥ졼
//
//   Originally written by KIYOTA Hiromitsu <1999/01/19>
//   Copyright (c) 1999 Hiromitsu Kiyota, kiyota@ds.mei.titech.ac.jp
//
// RCS: $Id: sim00006.mm,v 1.4 1999/05/31 03:30:17 kiyota Exp $

// Local options
//#define NOPLOT
//#define MULTIPLOT

// These are required #definitions.
#define TMD00006_USER_H "sim00006.h"
#define TMD00006_USER_MM "sim00006.mm"

// TMD00006_USER_H  #include 롣
#include "tmd00006.h"

Matrix F;

Func void
main()
{
  Matrix TC, XC, UC;
  Matrix link_eqs();
#ifndef NOPLOT
  List names;
  Integer i;
#ifdef MULTIPLOT
  Integer hmultiplot(...) require "hplot.mm";
#endif /* MULTIPLOT */
#endif /* ! NOPLOT */

  init_tmd00006(1); // Υߥ졼
//  init_tmd00006(); // Υߥ졼 (not given)

  F = Optimal(tmd00006(A), tmd00006(B),
	      diag([100.0], [1000.0], [10.0]), // Q
	      [1.0]); // r
  
  {TC, XC, UC} = Ode45Auto(0.0, 1.0,
#ifndef TMD00006_USER_DIFF
			   [0.0, -5e-3, 0.0]',
#else /* TMD00006_USER_DIFF */
			   [[0.0, -5e-3, 0.0],
			    [0.0, 0.0]]', // ưŪν
#endif /* ! TMD00006_USER_DIFF */
			   diff_tmd00006, link_eqs);
  print [[TC][XC][UC]] >> "sim.mat";

#ifndef NOPLOT
  names = {"I-I0", "x-x0(=y)", "dot_x", "V-V0(=u)", "-"};

#ifndef MULTIPLOT
   for (i = 1; i <= length(names); ++i)
     {
       if (names(i, String) == "-") { continue; }
       mgplot_grid(i, 1);
       mgplot(i, TC(1,:), [[XC][UC]](i,:), {names(i, String)});
     }
#else /* MULTIPLOT */
  hmultiplot(1, TC, [[XC][UC]], names);
#endif /* ! MULTIPLOT */
  pause;
#endif /* ! NOPLOT */
}


Func Matrix
link_eqs(t, xx)
     Real t;
     Matrix xx;
{
  Matrix uy;
  static Integer running;
  static Matrix u;
  Matrix x, y;

  if (running == 0) // ߥ졼󳫻ϻ
    {
      uy = Z(TMD00006_DIM_ALL_IOS,1);
      u = chop_input_tmd00006(uy);
      running = 1;
    }

  x = chop_state_tmd00006(xx);
  y = output_tmd00006(t, x, u);

  u = F*x; // ֤ΤäƤȤ褦;)

  uy = [[u]
	[y]];
  return uy;
}


#ifdef TMD00006_USER_DIFF
// ߡưŪ
Func Matrix
TMD00006_USER_DIFF(t, xx, uu)
     Real t;
     Matrix xx, uu;
{
  Matrix x, z, u, y; // z ϤǤϴ¬ξ֤ʤ

  x = chop_state_tmd00006(xx);
  z = chop_other_state_tmd00006(xx);
  u = chop_input_tmd00006(uu);
  y = output_tmd00006(t, x, u);
  // etc.

  return [1.0, -1.0]'; // ߡΤøʥʥߥ ;-)
}
#endif /* TMD00006_USER_DIFF */
