/* -*- MaTX -*-
 *
 * tmd00006.mm: TMD No. tmd00006 ¸ѼϤΥǥ
 *
 *  Originally written by KIYOTA Hiromitsu <1999/01/19>
 *  Copyright (c) 1999 Hiromitsu Kiyota, kiyota@ds.mei.titech.ac.jp
 *
 * RCS: $Id: tmd00006.mm,v 1.6 1999/06/29 03:50:38 kiyota Exp $
 */

#ifndef _TMD00006_MM
#define _TMD00006_MM

#ifndef TMD_EXTERN
#define TMD_EXTERN extern
#endif /* ! TMD_EXTERN */
#include "tmd00006.h"

// some definitions for local alist
#define _TMD_LALIST {"_tmd00006"}
#define _TMD_LIN_FLAG "linear_flag"

// just for simplicity... B)
#define tmd6(var) tmd00006(var)

Func void
init_tmd00006(linear_flag, params_flag, ...)
     Integer linear_flag, params_flag;
{
#ifndef TMD00006_DISABLE_HALIST
  List halist(...);
#endif /* ! TMD00006_DISABLE_HALIST */

  switch (nargs)
    {
    case 2:
      break;
    case 0:
      linear_flag = 1; // ǥե: ǥ
    case 1:
      params_flag = 0; // ǥե: ѥ᡼̤
      break;
    default:
      error("init_tmd00006(): Incorrect number of arguments. (nargs=%d)\n", nargs);
      break;
    }

  // ()Υե饰
#ifndef TMD00006_DISABLE_HALIST
  if (halist({_TMD_LALIST, "exists"}) == {})  // if not exist
    {
      halist({_TMD_LALIST, "clear"});  // new alist
    }
  halist(_TMD_LALIST, {{_TMD_LIN_FLAG, linear_flag}});
#else /* TMD00006_DISABLE_HALIST */
  tmd00006_flag = linear_flag;
#endif /* ! TMD00006_DISABLE_HALIST */

  if (params_flag == 0)
    {
      tmd6(L) = 0.7; /* H */			// żФΥ
      tmd6(R) = 12; /* ohm */			// żФ
      tmd6(K) = 1.37e-4; /* kgm^3/(sA)^2 */	// żФμϤФ
      tmd6(h) = 2.85e-2; /* m */		// żФħ
      tmd6(m) = 6.67e-2; /* kg */		// Ŵμ
      tmd6(g) = 9.8; /* m/s^2 */		// ϲ®

      tmd6(x0) = 2.00e-2; /* m */		// Ŵſʿ
      tmd6(I0) = sqrt(tmd6(m)*tmd6(g)*(tmd6(h)-tmd6(x0))^2/tmd6(K)); /* A */
      //                                           ʿή
      tmd6(V0) = tmd6(R)*tmd6(I0); /* V */	// ʿŰ
    }

  tmd6(A) = [[    -tmd6(R)/tmd6(L),                            0.0, 0.0]
	     [                 0.0,                            0.0, 1.0]
	     [2.0*tmd6(g)/tmd6(I0), 2.0*tmd6(g)/(tmd6(h)-tmd6(x0)), 0.0]];
  tmd6(B) = [1.0/tmd6(L), 0.0, 0.0]';
  tmd6(C) = [0.0, 1.0, 0.0];
  tmd6(D) = [0.0];
}


Func Matrix
diff_tmd00006(t, xx, uu)
     Real t;
     Matrix xx, uu;
{
  Matrix dxx;
#ifndef TMD00006_DISABLE_HALIST
  List halist(...);
#endif /* ! TMD00006_DISABLE_HALIST */
  Matrix dx, x, u;
#ifdef TMD00006_USER_DIFF
  Matrix TMD00006_USER_DIFF();
#endif /* TMD00006_USER_DIFF */

  x = chop_state_tmd00006(xx);
  u = chop_input_tmd00006(uu);

#ifndef TMD00006_DISABLE_HALIST
  if (halist(_TMD_LALIST, {_TMD_LIN_FLAG}) == {0}) // ǥ
#else /* TMD00006_DISABLE_HALIST */
  if (tmd00006_flag == 0) // ǥ
#endif /* ! TMD00006_DISABLE_HALIST */
    {
      // not given.
      dx = tmd6(A)*x + tmd6(B)*u;
    }
  else // ǥ
    {
      dx = tmd6(A)*x + tmd6(B)*u;
    }

  dxx = [[dx]
#ifdef TMD00006_USER_DIFF
	 [TMD00006_USER_DIFF(t, xx, uu)]
#endif /* TMD00006_USER_DIFF */
	 ];
  return dxx;
}


Func Matrix
output_tmd00006(t, xx, uu)
     Real t;
     Matrix xx, uu;
{
  Matrix x, u, y;

  x = chop_state_tmd00006(xx);
  u = chop_input_tmd00006(uu);

  y = tmd6(C)*x + tmd6(D)*u;

  return y;
}

#undef tmd6
#undef _TMD_LALIST
#undef _TMD_LIN_FLAG

#endif /* !_TMD00006_MM */
